



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux 文件压缩与归档</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux 文件压缩与归档</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-11 08:07:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Linux 文件压缩与归档<br />
.note-content  {font-family: 'Helvetica Neue', Arial, 'Hiragino Sans GB', STHeiti, 'Microsoft YaHei', 'WenQuanYi Micro Hei', SimSun, Song, sans-serif;}</p>
<div>
<blockquote><p>之前总是将linux 的文件打包压缩命令混为一体，工作中我也很少的去压缩和打包文件。应用场景也多是从网上下载一个软件包，然后使用tar命令解压一下，基本上没有遇到什么阻碍。</p>
<p>回头看这两年写的文章，技术的含量不高，大多数是在进行知识的总结和思考。特别是这半年来，学习的动力虽然没有减少，但是却很少写博客了。书读了不少，linux的视屏看了不少，以前工作中或者书籍中难以理解的名词和概念如今也迎刃而解了。学到的知识没有及时的总结，可能随着时间就慢慢的遗忘了。今后会及时的将所学的知识进行总结，贴到博客中。</p></blockquote>
<hr>
<h4>一、压缩</h4>
<p><strong>为什么要压缩？</strong> <br /><br />
以Apache网页压缩的gzip举例，使用压缩后，占用的带宽资源更少，传输的速率更快。在磁盘上使用压缩可以缩减文件的大小，使得同样大小的磁盘可以储存更多的信息。</p>
<p><strong>压缩的原理？</strong> <br /><br />
许多文件都是AscII 文本文件，文本文件中许多信息是重复的，比如一篇文章中多次出现apple 和banana 。那么就可以使用0 代表apple，1代表banana。解压的时候再替换过来，这样子文件的大小能够大大的缩减。压缩有许多种算法，每种算法也可以指定压缩比。压缩比越高，压缩时间越长，响应的解压时间也要越长。因此不是说压缩比越高越好。 <br /><br />
linux 中常用的压缩命令有，gzip、bzip2, xz。</p>
<p><strong>压缩命令</strong></p>
<pre class="prettyprint linenums"><code>1.gzip<br>gzip 压缩之后会删除源文件，压缩后的文件名后缀为.gz<br>gzip test.txt 压缩文件<br>gzip -d test.txt 解压文件<br>其中-d选项的意思是decompress（解压）的意思。<br></code></pre>
<pre class="prettyprint linenums"><code>2、bzip2<br>bzip2 压缩之后的格式为bz2<br>bzip2 test.txt<br>bzip2 -kd test.txt<br></code></pre>
<pre class="prettyprint linenums"><code>3、xz<br>xz 压缩之后的格式为.xz<br>xz test.txt<br>xz -kd test.txt<br></code></pre>
<pre class="prettyprint linenums"><code>4、zip 与unzip<br>zip  test.txt.zip ./test.txt<br>unzip test.txt.zip <br></code></pre>
<blockquote><p>这些压缩命令都有其他的选项，可以使用man 命令 来查看。这些命令同时也具有另外与之匹配的解压命令，但为了简化记忆，统一使用 command -d 来解压文件,使用-k 可以保留源文件。</p></blockquote>
<h4>二、归档</h4>
<blockquote><p>什么是tar ,man tar 之后很容易看到这个命令的缩写由来。GNU ’tar‘ saves many files togerther into a single tape or disk archive, and can restore indeividual files from the archive. <br /><br />
  tar 是tape 和 archive 的缩写。tape 是胶带捆绑。archive是归档。也就是说tar命令并不进行文档的压缩。那么我们平时所使用的 tar 命令为什么能够实现压缩和打包的功能呢？</p></blockquote>
<p><strong>tar 如何实现文件的压缩功能？</strong></p>
<p>tar 命令在工作的时候会调用之前提到的压缩命令，当归档的时候可以指定使用某种压缩算法，也可以不压缩只打包。比如压缩的时候，使用z 表示使用gzip压缩，使用j 表示使用bzip2 压缩。</p>
<p><strong>tar 命令用法：</strong></p>
<pre class="prettyprint linenums"><code>tar <br>    -c  //create 创建归档文件<br>    -f  //file   操作的归档文件<br>    -x  //extrate 展开归档<br></code></pre>
<pre class="prettyprint linenums"><code>打包文件与展开归档<br>tar -cf test.tar ./test1.txt ./test2.txt ./test3.txt  //归档文件<br>tar -xf test.tar //展开归档<br></code></pre>
<pre class="prettyprint linenums"><code>使用gzip 压缩与解压<br>tar -zcf test.tar.gz ./test1.txt ./test2.txt ./test3.txt<br>tar -zxf test.tar.gz <br></code></pre>
<pre class="prettyprint linenums"><code>使用bzip2 压缩与解压<br>tar -jcf test.tar.gz ./test1.txt ./test2.txt ./test3.txt<br>tar -jxf test.tar.gz <br></code></pre>
<pre class="prettyprint linenums"><code>使用xz压缩与解压<br>tar -Jcf test.tar.gz ./test1.txt ./test2.txt ./test3.txt<br>tar -Jxf test.tar.gz <br></code></pre>
<p><strong><code>Help Me 这么多解压命令怎么记得住？</code></strong></p>
<pre class="prettyprint linenums"><code>压缩算法缩写：<br>z  -------&gt; gzip<br>j  -------&gt; bzip2<br>J  -------&gt; xz<br></code></pre>
<p><strong>查看归档中的文件列表</strong></p>
<pre class="prettyprint linenums"><code>tar -tf  test.tar.gz //查看压缩文档中文档列表，而不必解压。<br></code></pre>
<h4>三、实测压缩效果</h4>
<pre class="prettyprint linenums"><code>[root@roverliang test]# du -h<br>7.7M    ./profiled/bin<br>7.8M    ./profiled<br>7.8M    .<br /><br />//压缩过后的文件大小。<br>[root@roverliang test]# ll -Ah<br>total 8.6M<br>-rw-r--r-- 1 root root 3.0M Nov  3 15:58 file.tar.bz2<br>-rw-r--r-- 1 root root 3.4M Nov  3 15:56 file.tar.gz<br>-rw-r--r-- 1 root root 2.3M Nov  3 15:58 file.tar.xz<br>drwxr-xr-x 3 root root 4.0K Nov  3 15:44 profiled<br></code></pre>
<p>压缩之前文件夹大小是7.8M ,压缩后最小的仅有2.3M,最大的也仅仅是3.4M. <br /><br />
我们可以看下linux kernel 的官网，看下内核使用的是那种压缩格式。 <br /><br />
<a href="https://www.kernel.org/" rel="external nofollow noreferrer">https://www.kernel.org/</a> <br /><br />
可以看到,linux 的内核也是使用了xz 的格式。</p>
<h4>四、其他内容</h4>
<p>还有一些选项，我认为是没有必要的比如压缩或者解压的使用-v选项，除了满屏幕飘过乱码外，我觉得并没有什么作用。这些命令与linux的哲学思想不符合，linux的哲学思想是尽量减少与用户的交互，这本质上也反映了李纳斯的内敛性格。</p>
<p><code>文章中如果有不正确的地方，欢迎在评论区讨论，共同学习一起提高。</code></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2g4nx8.html">iOS&mdash;&mdash;Core Animation 知识摘抄（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wwpvlq.html">redhat enterprixe 5&period;0 samba 服务器 rpm 安装及配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mzej1q.html">《day16&lowbar;多线程细节&lowbar;Eclipse使用》</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mzjdeq.html">CentOS安装时小坑记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmkr109.html">php命令行用法简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1gmv28.html">数据库字段类型中char和Varchar区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y1673q.html">STL 六大组件 功能与运用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1ezy39.html">spring aop例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn1l2pq.html">Web API零碎知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o65gn9.html">idea15破解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mer5m8.html">Python之路--你不知道的platform</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mewjw2q.html">关于quotename的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pll1y8.html">团队作业4&mdash;&mdash;第一次项目冲刺（Alpha版本） Day4</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1n1x1q.html">Swagger和Postman的配置和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2nen6q.html">for循环：用turtle画一颗五角星2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll465eq.html">js里面的全局属性 全局对象 全局函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vw4l0q.html">没听说过这些，就不要说你懂并发了，two。</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vwog5q.html">Oracle中的SQL分页查询原理和方法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp0xwl9.html">Python 的 if &lowbar;&lowbar;name&lowbar;&lowbar; &equals;&equals; &amp;&num;39&semi;&lowbar;&lowbar;main&lowbar;&lowbar;&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn773kq.html">转：在 Ubuntu 上使用 Nginx 部署 Flask 应用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8mnn36q.html">Mac下查看端口占用</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pjdkz9.html">android Activity介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn1jkg8.html">IOS之Objective-C学习 策略模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pjm7z9.html">Spark SQL 之 Data Sources</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96o7mn9.html">win10打开IL DASM步骤&colon;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93xd3g9.html">Spring MVC之&commat;RequestParam &commat;RequestBody &commat;RequestHeader 等详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z1rnd9.html">安卓Socket连接实现连接实现发送接收数据，openwrt wifi转串口连接单片机实现控制</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7mny1q.html">Bootsrap基本应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e1opm9.html">Dipole Antenna &colon; 2</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pj3d79.html">BZOJ 1691&colon; &lbrack;Usaco2007 Dec&rsqb;挑剔的美食家 &lbrack;treap 贪心&rsqb;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
